Index: branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg
===================================================================
--- branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 388)
+++ branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 409)
@@ -151,5 +151,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
Index: branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_2view.cfg
===================================================================
--- branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 388)
+++ branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 409)
@@ -145,5 +145,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
Index: branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg
===================================================================
--- branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 388)
+++ branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 409)
@@ -155,5 +155,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
Index: branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_3view.cfg
===================================================================
--- branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 388)
+++ branches/HTM-6.2-dev1-LG/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 409)
@@ -147,5 +147,6 @@
 ALFPicBasedEncode              : 1                                 # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
 MaxNumOffsetsPerPic            : 2048                              # default
-SAOInterleaving                : 0                                 # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
+SAOLcuBoundary              : 0                                 # 0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas
+SAOLcuBasedOptimization : 1                                  # 0: SAO picture-based optimization, 1: SAO LCU-based optimization 
 ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
 weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)