Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 417)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 418)
@@ -1747,5 +1747,5 @@
   memcpy( rpcCU->getVSPIndex()          + m_uiAbsIdxInLCU, m_piVSPIndex,         iSizeInChar );
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
-  memcpy( rpcCU->getVSPDir  ()           + m_uiAbsIdxInLCU, m_piVSPDir  ,         iSizeInChar );
+  memcpy( rpcCU->getVSPDir  ()          + m_uiAbsIdxInLCU, m_piVSPDir  ,         iSizeInChar );
 #endif
 #endif
@@ -1884,5 +1884,5 @@
   memcpy( rpcCU->getVSPIndex()          + uiPartOffset, m_piVSPIndex,          iSizeInChar );
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
-  memcpy( rpcCU->getVSPDir  ()           + uiPartOffset, m_piVSPDir  ,         iSizeInChar );
+  memcpy( rpcCU->getVSPDir  ()          + uiPartOffset, m_piVSPDir  ,          iSizeInChar );
 #endif
 #endif
@@ -3865,5 +3865,5 @@
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
       cDisInfo.m_aListIdx[0] = getDvInfo(uiAbsPartIdx).m_aListIdx[0];
-      cDisInfo.m_aRefIdx[0] = getDvInfo(uiAbsPartIdx).m_aRefIdx[0];
+      cDisInfo.m_aRefIdx[0]  = getDvInfo(uiAbsPartIdx).m_aRefIdx[0];
 #endif
 #endif
@@ -4380,5 +4380,5 @@
 #endif
 #if MERL_VSP_C0152
-     xInheritVspMode( pcCULeftBottom, uiLeftBottomPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
+    xInheritVspMode( pcCULeftBottom, uiLeftBottomPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
        , iVSPDirTrue
@@ -4438,5 +4438,5 @@
 #endif
 #if MERL_VSP_C0152
-     xInheritVspMode( pcCUAboveLeft, uiAboveLeftPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
+      xInheritVspMode( pcCUAboveLeft, uiAboveLeftPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
        , iVSPDirTrue
@@ -5521,5 +5521,5 @@
 Bool TComDataCU::getRefListAndRefFrmIdx(Int targetRefViewIdx, RefPicList& eRefPicList, Int& refFrmIdx)
 {
-  Bool isFound  = false;
+  Bool isFound = false;
   RefPicList privateRefPicList = REF_PIC_LIST_0;
 
@@ -5894,5 +5894,4 @@
     pDInfo->m_aRefIdx [ pDInfo->iN ]  = -1-refFrmIdx;
     assert(pDInfo->m_aRefIdx [ pDInfo->iN ] < 0);
-
 #endif
     pDInfo->m_acMvCand[pDInfo->iN] = defaultDV;
Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.h	(revision 417)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.h	(revision 418)
@@ -290,5 +290,5 @@
   inline Void   xInheritVspMode       ( TComDataCU* pcCURef, UInt uiIdx, Bool* bVspMvZeroDone, Int iCount, Int* iVSPIndexTrue, TComMvField* pcMvFieldNeighbours, DisInfo* pDInfo
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
-    ,Int *iVSPDirTrue
+                                      , Int *iVSPDirTrue
 #endif
     ) ;
Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.cpp	(revision 417)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.cpp	(revision 418)
@@ -837,5 +837,5 @@
   assert(pcBaseViewTxtPicYuv != NULL);
 
-  //initialize the LUT according to the reference view idx
+  // initialize the LUT according to the reference view idx
   pcCU->getSlice()->getBWVSPLUTParam(pShiftLUT, iShiftPrec, pRefPicBaseTxt->getViewId());
 
Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TypeDef.h	(revision 417)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TypeDef.h	(revision 418)
@@ -213,5 +213,5 @@
 #define MERL_VSP_BLOCKSIZE_C0152             4 // JCT3V-C0152: VSP block size, supported values: 1, 2 and 4.
 #define MERL_VSP_C0152_BugFix_ForNoDepthCase 0 // MERL bugfix for test condition of no depth
-define MERL_CVSP_D0165                       0 // JCT3V-D0165: 1: enable CVSP; 0: disable CVSP.
+#define MERL_CVSP_D0165                      0 // JCT3V-D0165: 1: enable CVSP; 0: disable CVSP.
 #define MERL_VSP_NBDV_RefVId_Fix_D0166       0 // JCT3V-D0166: 1: fix the NBDV with ref view selectioin; 0: always use base view with refViewIdx=0
 #define MERL_Bi_VSP_D0166                    0 // JCT3V-D0166: 1: add supporting for Bi-VSP, the code under the macro can also handle uni-direction VSP
Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 417)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 418)
@@ -62,5 +62,5 @@
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
   for(Int iNumCount = 0; iNumCount < MAX_VIEW_NUM; iNumCount++)
-    m_pcListDepthPic[iNumCount] =NULL;
+    m_pcListDepthPic[iNumCount] = NULL;
 #endif
 #if FCO_DVP_REFINE_C0132_C0170
@@ -155,5 +155,5 @@
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
   for(Int iNumCount = 0; iNumCount < MAX_VIEW_NUM; iNumCount++)
-    m_pcListDepthPic[iNumCount] =NULL;
+    m_pcListDepthPic[iNumCount] = NULL;
 #endif
 }
@@ -834,9 +834,9 @@
   pcSlice->setRefPicBaseDepth(m_pPicBaseDepth);
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
-  for (Int refviewId=0; refviewId < pcSlice->getViewId(); refviewId++)
-  {
-    assert( m_pcListDepthPic[refviewId] );
-    pcSlice->setListDepthPic(m_pcListDepthPic[refviewId], refviewId);
-    pcSlice->setBWVSPLUTParam(m_aiShiftLUT[refviewId], m_iShiftPrec, refviewId);
+  for (Int refViewId=0; refViewId < pcSlice->getViewId(); refViewId++)
+  {
+    assert( m_pcListDepthPic[refViewId] );
+    pcSlice->setListDepthPic(m_pcListDepthPic[refViewId], refViewId);
+    pcSlice->setBWVSPLUTParam(m_aiShiftLUT[refViewId], m_iShiftPrec, refViewId);
   }
 #endif