Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 421)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 422)
@@ -3862,8 +3862,10 @@
       cDisInfo.m_acMvCandNoRef[0] = getDvInfo(uiAbsPartIdx).m_acMvCandNoRef[0];
 #endif
+#if MERL_General_Fix
 #if MERL_VSP_C0152
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
       cDisInfo.m_aListIdx[0] = getDvInfo(uiAbsPartIdx).m_aListIdx[0];
       cDisInfo.m_aRefIdx[0]  = getDvInfo(uiAbsPartIdx).m_aRefIdx[0];
+#endif
 #endif
 #endif
@@ -5380,4 +5382,5 @@
 
           TComPic* picDepth = NULL;
+#if MERL_General_Fix
 #if MERL_VSP_C0152
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
@@ -5388,4 +5391,5 @@
 #else
           picDepth = getSlice()->getRefPicBaseDepth();
+#endif
 #endif
 #endif
Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.cpp	(revision 421)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.cpp	(revision 422)
@@ -50,8 +50,10 @@
 #endif
 
+#if MERL_General_Fix
 #if MERL_VSP_C0152
 #if MERL_CVSP_D0165
 Int TComPrediction::m_iRangeLuma[12]   = {14, 34, 21, 15, 36, 26, 21, 49, 41, 36, 80, 72};
 Int TComPrediction::m_iRangeChroma[12] = { 2,  8,  5,  4, 11,  9,  8, 19, 17, 15, 34, 32};
+#endif
 #endif
 #endif
@@ -1864,4 +1866,5 @@
 #endif
   
+#if MERL_General_Fix
 #if MERL_VSP_BLOCKSIZE_C0152 == 1
 #if MERL_CVSP_D0165
@@ -1934,4 +1937,5 @@
 #endif
 #endif
+#endif
 
 #if MERL_VSP_BLOCKSIZE_C0152 != 1
@@ -2062,4 +2066,22 @@
   Int dstStrideBlock = dstStride * nTxtPerDepthY;
   Int depStrideBlock = depStride * nDepthPerTxtY;
+
+#if !MERL_Bi_VSP_D0166
+  if (isDepth)
+  {
+     // DT: Since the call for this function is redundant, ..
+     for (Int y = 0; y < sizeY; y++)
+     {
+       for (Int x = 0; x < sizeX; x++)
+       {
+         dstCb[x] = 128;
+         dstCr[x] = 128;
+       }
+       dstCb += dstStride;
+       dstCr += dstStride;
+     }
+     return;
+  }
+#endif
 
   if ( widthChroma > widthDepth ) // We assume
@@ -2150,4 +2172,5 @@
 
 
+#if MERL_General_Fix
 #if MERL_VSP_BLOCKSIZE_C0152 == 1
 #if MERL_CVSP_D0165
@@ -2216,4 +2239,5 @@
 #endif
 #endif
+#endif
 
     // (sizeX, sizeY) is Chroma block size
Index: branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.h	(revision 421)
+++ branches/HTM-6.2-dev2-MERL/source/Lib/TLibCommon/TComPrediction.h	(revision 422)
@@ -115,4 +115,11 @@
       );
 
+#if !MERL_General_Fix
+#if MERL_VSP_C0152
+  Void xPredInterUniBWVSP         ( TComDataCU* pcCU,                          UInt uiPartAddr, UInt uiAbsPartIdx,               Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Int iPartIdx, Bool bPrdDepthMap, UInt uiSubSampExpX, UInt uiSubSampExpY, Bool bi=false );
+  Void xPredInterBiBWVSP          ( TComDataCU* pcCU,                          UInt uiPartAddr, UInt uiAbsPartIdx,               Int iWidth, Int iHeight, UInt uiSubSampExpX, UInt uiSubSampExpY, TComYuv*& rpcYuvPred, Int iPartIdx, Bool bPrdDepthMap );
+#endif
+#endif
+
 #if DEPTH_MAP_GENERATION
   Void xWeightedAveragePdm      ( TComDataCU* pcCU, TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, Int iRefIdx0, Int iRefIdx1, UInt uiPartAddr, Int iWidth, Int iHeight, TComYuv*& rpcYuvDst, UInt uiSubSampExpX, UInt uiSubSampExpY );
@@ -152,11 +159,12 @@
   Void xWeightedAverage         ( TComDataCU* pcCU, TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, Int iRefIdx0, Int iRefIdx1, UInt uiPartAddr, Int iWidth, Int iHeight, TComYuv*& rpcYuvDst );
 #endif
-#if MERL_VSP_C0152
-  Void xPredInterVSPBlk(TComDataCU* pcCU, UInt uiPartAddr, UInt uiAbsPartIdx, Int iWidth, Int iHeight, TComMv cMv, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi 
+
+#if MERL_VSP_C0152
 #if !MERL_Bi_VSP_D0166
-                                     , Int vspIdx
-#endif
-    );
-#if MERL_Bi_VSP_D0166
+  Void xPredInterLumaBlkFromDM    ( TComPicYuv *refPic, TComPicYuv *pPicBaseDepth, Int* pShiftLUT, Int iShiftPrec, TComMv *mv, UInt partAddr,Int posX, Int posY, Int sizeX, Int sizeY, Bool isDepth, Int vspIdx
+                                  , TComYuv *&dstPic );
+  Void xPredInterChromaBlkFromDM  ( TComPicYuv *refPic, TComPicYuv *pPicBaseDepth, Int* pShiftLUT, Int iShiftPrec, TComMv *mv, UInt partAddr,Int posX, Int posY, Int sizeX, Int sizeY, Bool isDepth, Int vspIdx
+                                  , TComYuv *&dstPic );
+#else
   TComPic*  xGetVspRefTxt(TComDataCU* pcCU, UInt uiPartAddr, RefPicList eRefPicList);
   Void xPredInterLumaBlkFromDM    ( TComPicYuv *refPic, TComPicYuv *pPicBaseDepth, Int* pShiftLUT, Int iShiftPrec, TComMv *mv, UInt partAddr,Int posX, Int posY, Int sizeX, Int sizeY, Bool isDepth, 
@@ -164,11 +172,7 @@
   Void xPredInterChromaBlkFromDM  ( TComPicYuv *refPic, TComPicYuv *pPicBaseDepth, Int* pShiftLUT, Int iShiftPrec, TComMv *mv, UInt partAddr,Int posX, Int posY, Int sizeX, Int sizeY, Bool isDepth,
     TComYuv *&dstPic, Bool bi);
-#else
-  Void xPredInterLumaBlkFromDM    ( TComPicYuv *refPic, TComPicYuv *pPicBaseDepth, Int* pShiftLUT, Int iShiftPrec, TComMv *mv, UInt partAddr,Int posX, Int posY, Int sizeX, Int sizeY, Bool isDepth, Int vspIdx,
-                                  TComYuv *&dstPic );
-  Void xPredInterChromaBlkFromDM  ( TComPicYuv *refPic, TComPicYuv *pPicBaseDepth, Int* pShiftLUT, Int iShiftPrec, TComMv *mv, UInt partAddr,Int posX, Int posY, Int sizeX, Int sizeY, Bool isDepth, Int vspIdx,
-                                  TComYuv *&dstPic );
-#endif
-#endif
+#endif
+#endif
+
   Void xGetLLSPrediction ( TComPattern* pcPattern, Int* pSrc0, Int iSrcStride, Pel* pDst0, Int iDstStride, UInt uiWidth, UInt uiHeight, UInt uiExt0 );
 #if LGE_ILLUCOMP_B0045
@@ -178,4 +182,14 @@
   Void xDCPredFiltering( Int* pSrc, Int iSrcStride, Pel*& rpDst, Int iDstStride, Int iWidth, Int iHeight );
   Bool xCheckIdenticalMotion    ( TComDataCU* pcCU, UInt PartAddr);
+
+#if MERL_General_Fix
+#if MERL_VSP_C0152
+  Void xPredInterVSPBlk(TComDataCU* pcCU, UInt uiPartAddr, UInt uiAbsPartIdx, Int iWidth, Int iHeight, TComMv cMv, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi 
+#if !MERL_Bi_VSP_D0166
+                                     , Int vspIdx
+#endif
+    );
+#endif
+#endif
 
 #if HHI_DMM_WEDGE_INTRA